package com.wmdigit.digitransfer.handler;

import com.wmdigit.digitransfer.bean.Commodity;
import com.wmdigit.digitransfer.util.ByteBufferUtils;
import com.wmdigit.digitransfer.util.Hex2BytesUtils;

import java.io.DataInputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.net.Socket;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public abstract class ScalesApiHandler implements ObjectHandler {
    private Socket socket;
    private int addressFour;
    private Printer printer;

    public ScalesApiHandler() {
    }

    public void run() {
        try {
            DataInputStream socketIn = new DataInputStream(socket.getInputStream());
            byte[] mReceivedBuffer = new byte[1600];
            int read = 0;
            while ((read = socketIn.read(mReceivedBuffer)) != -1) {
                if (socketIn.available() == 0) {
                    ByteBuffer byteBuffer = ByteBuffer.allocate(read);
                    byteBuffer.put(mReceivedBuffer, 0, read);
                    byteBuffer.order(ByteOrder.LITTLE_ENDIAN).flip();
                    byte[] byteArray = byteBuffer.array();
                    printer.d(Hex2BytesUtils.bytesToHexString2(byteArray));
                    switch (byteArray[0]) {
                        case (byte) 247:
                            String hexString = Hex2BytesUtils.bytesToHexString(byteArray);
                            String hex = Integer.toHexString(255 & addressFour);
                            String hex2;
                            if (addressFour > 153) {
                                hex2 = "F74F00000" + addressFour;
                            } else {
                                hex2 = "F74F000000" + hex;
                            }
                            printer.d(hex2);
                            if (hexString.equals("F74F00000000")) {
                                String s1 = "00 00 00 " + hex + " 00 b6 00 00 00 00 00 01 00 00 00 01 00 00 00 00 16 01 04 01 00 20 10 01 24 00 00 00 00 00 01 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 60 03 " +
                                        "77 5e e0 c0 a8 31 " +
                                        hex + " 00 00 00 00 00 31 30 36 00 00 00 09 02 09 71 52 00 00 00 11 00 00 83 47 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00";
                                //c0 =192,a8 =168,

                                byte[] bytes1 = Hex2BytesUtils.string2Bytes(s1);
                                replyCommand(bytes1);

                            } else if (hexString.equals(hex2)) {
//                                printer.d(hex2);
                                byte[] bytes1 = new byte[1];
                                bytes1[0] = (byte) 226;
                                replyCommand(bytes1);
                            }
                            break;
                        case (byte) 241:
                            switch (byteArray[1]) {
                                case (byte) 37:
                                    Commodity commodity = new Commodity();
                                    byteBuffer.position(2);

                                    int pluNo = ByteBufferUtils.bytesToInteger(byteBuffer, 4);
                                    commodity.setPluNo(pluNo);
                                    byteBuffer.position(13);
                                    int weigh = ByteBufferUtils.bytesToInt(byteBuffer);
                                    commodity.setWeightingFlag(weigh);
                                    double unitPriceDouble = ByteBufferUtils.bytesToInteger(byteBuffer, 3);
                                    double unitPrice = unitPriceDouble / 100;
                                    commodity.setUnitPrice(unitPrice);
                                    int barcodeFlag = ByteBufferUtils.bytesToInt(byteBuffer);
//                                    System.out.println("标签格式样式:" + barcodeFlag);
                                    commodity.setBarcodeFlag(barcodeFlag);
                                    int barcodeFormat = ByteBufferUtils.bytesToInt(byteBuffer);
//                                    System.out.println("条码格式BarcodeFormat:" + barcodeFormat);
                                    commodity.setBarcodeFormat(barcodeFormat);
//                                                        byte[] bytes1 = subBytes(receivedBytes, 19, 1);
                                    String labelFormat1 = ByteBufferUtils.bytesToString(byteBuffer, 1);
                                    commodity.setLabelFormat1(labelFormat1);

//                                    System.out.println("条码前缀" + labelFormat1);

                                    String itemCode = ByteBufferUtils.bytesToString(byteBuffer, 5).replaceAll("(0)+$", "");
//                                    System.out.println("项目代码:" + itemCode);
                                    commodity.setItemCode(itemCode);
                                    byteBuffer.position(byteBuffer.position() + 1);
                                    String groupNo = String.valueOf(ByteBufferUtils.bytesToInteger(byteBuffer, 2));
//                                    System.out.println("MGNo 主组:" + groupNo);
                                    commodity.setMgNo(groupNo);
                                    int usedByDate = ByteBufferUtils.bytesToInteger(byteBuffer, 2);
                                    System.out.println("售出日期：UsedByDate:" + usedByDate);
                                    commodity.setUsedByDate(usedByDate);
                                    int sellByDate = ByteBufferUtils.bytesToInteger(byteBuffer, 2);
                                    System.out.println("保质期：SellByDate:" + sellByDate);
                                    commodity.setSellByDate(sellByDate);
                                    int packedByDate = ByteBufferUtils.bytesToInteger(byteBuffer, 2);
                                    commodity.setPackedByDate(packedByDate);
                                    System.out.println("包装日期，PackedByDate:" + packedByDate);

                                    commodity.setPackedByDate(packedByDate);
//                                    int pos = 152;
//                                    int i = 0;
//                                    boolean isResult = true;
//                                    while (isResult) {
//
//                                    }
                                    for (int pos = 152; pos > 0; pos--) {
                                        printer.i("pos:" + pos);
                                        byteBuffer.position(pos);
                                        int commodity1Start = byteBuffer.get();
                                        printer.i("commodity1Start= " + commodity1Start);
                                        if (commodity1Start == 3) {
                                            getCommodity(byteBuffer, commodity);
                                            byteBuffer.position(pos - 104);
                                            int traceabilityFlag = ByteBufferUtils.bytesToInt(byteBuffer);
                                            int traceabilityNo = ByteBufferUtils.bytesToInteger(byteBuffer, 2);
                                            printer.d("追溯码开关" + traceabilityFlag + ",追溯码内容" + traceabilityNo);
                                            break;
                                        }
                                    }

//                                     else {
//                                        byteBuffer.position(150);
//                                        commodity1Start = byteBuffer.get();
//                                        if (commodity1Start == 3) {
//                                            getCommodity(byteBuffer, commodity);
//                                        }else {
//                                            byteBuffer.position(148);
//                                            commodity1Start = byteBuffer.get();
//                                            if (commodity1Start == 3) {
//                                                getCommodity(byteBuffer, commodity);
//                                            }
//                                        }
//                                    }


                                    downPlu(commodity);

                                    byte[] bytes3 = new byte[1];
                                    bytes3[0] = 6;
                                    replyCommand(bytes3);
                                    break;
                                case (byte) 176:
                                    byteBuffer.position(12);
                                    int i = byteBuffer.array().length - 1 - 12;
                                    byte[] bytes = new byte[i];
                                    byteBuffer.get(bytes);
                                    String s = new String(byteArray, "GBK");
                                    System.out.println(s);

                                    byte[] bytes4 = new byte[1];
                                    bytes4[0] = (byte) 225;
                                    replyCommand(bytes4);
                                    break;
                            }
                    }
                }
            }
        } catch (Exception var12) {
            var12.printStackTrace();
        } finally {
            if (this.socket != null) {
                try {
                    this.socket.close();
                } catch (IOException var11) {
                    var11.printStackTrace();
                }
            }

        }

    }

    private void getCommodity(ByteBuffer byteBuffer, Commodity commodity) throws UnsupportedEncodingException {
        int commodity1Font = ByteBufferUtils.bytesToInt(byteBuffer);
        printer.d("commodity1Font：" + commodity1Font);
        int commodity1Length = ByteBufferUtils.bytesToInt(byteBuffer);
        String commodity1 = ByteBufferUtils.bytesToHexString(byteBuffer, commodity1Length);
        commodity.setCommodity1(commodity1);
        int commodity2Start = byteBuffer.get();
        if (commodity2Start == 13) {
            int commodity2Font = ByteBufferUtils.bytesToInt(byteBuffer);
//            System.out.println("commodity2Font：" + commodity2Font);
            int commodity2Length = ByteBufferUtils.bytesToInt(byteBuffer);
            String commodity2 = ByteBufferUtils.bytesToHexString(byteBuffer, commodity2Length);
            commodity.setCommodity2(commodity2);
            int commodity3Start = byteBuffer.get();
            if (commodity3Start == 13) {
                int commodity3Font = ByteBufferUtils.bytesToInt(byteBuffer);
//                System.out.println("commodity3Font：" + commodity3Font);
                int commodity3Length = ByteBufferUtils.bytesToInt(byteBuffer);
                String commodity3 = ByteBufferUtils.bytesToHexString(byteBuffer, commodity3Length);
                commodity.setCommodity3(commodity3);
                byte commodity4Start = byteBuffer.get();
                if (commodity4Start == 13) {
                    int commodity4Font = ByteBufferUtils.bytesToInt(byteBuffer);
//                    System.out.println("commodity4Font：" + commodity4Font);
                    int commodity4Length = ByteBufferUtils.bytesToInt(byteBuffer);
                    String commodity4 = ByteBufferUtils.bytesToHexString(byteBuffer, commodity4Length);
                    commodity.setCommodity4(commodity4);
                    byte ingredient1Start = byteBuffer.get();
                    if (ingredient1Start == 12) {
                        getIngredient(byteBuffer, commodity);
                    }
                } else {
                    getIngredient(byteBuffer, commodity);
                }
            } else {
                getIngredient(byteBuffer, commodity);
            }
        } else if (commodity2Start == 12) {
            getIngredient(byteBuffer, commodity);
        }
    }

    private void getIngredient(ByteBuffer byteBuffer, Commodity commodity) throws UnsupportedEncodingException {
        int Ingredient1Font = ByteBufferUtils.bytesToInt(byteBuffer);
        System.out.println("Ingredient1Font：" + Ingredient1Font);
        if (Ingredient1Font == 0) {
            return;
        }
        int ingredient1Length = ByteBufferUtils.bytesToInt(byteBuffer);
        String ingredient1 = ByteBufferUtils.bytesToHexString(byteBuffer, ingredient1Length);
        commodity.setIngredient1(ingredient1);
        if (byteBuffer.get() == 13) {
            int Ingredient2Font = ByteBufferUtils.bytesToInt(byteBuffer);
            System.out.println("Ingredient2Font：" + Ingredient2Font);
            int ingredient2Length = ByteBufferUtils.bytesToInt(byteBuffer);
            String ingredient2 = ByteBufferUtils.bytesToHexString(byteBuffer, ingredient2Length);
            commodity.setIngredient2(ingredient2);
            if (byteBuffer.get() == 13) {
                int Ingredient3Font = ByteBufferUtils.bytesToInt(byteBuffer);
                System.out.println("Ingredient3Font：" + Ingredient3Font);
                int ingredient3Length = ByteBufferUtils.bytesToInt(byteBuffer);
                String ingredient3 = ByteBufferUtils.bytesToHexString(byteBuffer, ingredient3Length);
                commodity.setIngredient3(ingredient3);
                if (byteBuffer.get() == 13) {
                    int Ingredient4Font = ByteBufferUtils.bytesToInt(byteBuffer);
                    System.out.println("Ingredient4Font：" + Ingredient4Font);
                    int ingredient4Length = ByteBufferUtils.bytesToInt(byteBuffer);
                    String ingredient4 = ByteBufferUtils.bytesToHexString(byteBuffer, ingredient4Length);
                    commodity.setIngredient4(ingredient4);
                    if (byteBuffer.get() == 13) {
                        int Ingredient5Font = ByteBufferUtils.bytesToInt(byteBuffer);
                        System.out.println("Ingredient5Font：" + Ingredient5Font);
                        int ingredient5Length = ByteBufferUtils.bytesToInt(byteBuffer);
                        String ingredient5 = ByteBufferUtils.bytesToHexString(byteBuffer, ingredient5Length);
                        commodity.setIngredient5(ingredient5);
                        if (byteBuffer.get() == 12) {
                            getSpecialMessage(byteBuffer, commodity);
                        }
                    } else {
                        getSpecialMessage(byteBuffer, commodity);
                    }

                } else {
                    getSpecialMessage(byteBuffer, commodity);
                }
            } else {
                getSpecialMessage(byteBuffer, commodity);
            }
        } else {
            getSpecialMessage(byteBuffer, commodity);
        }
    }

    private void getSpecialMessage(ByteBuffer byteBuffer, Commodity commodity) throws UnsupportedEncodingException {
        int SpecialMessage1Font = ByteBufferUtils.bytesToInt(byteBuffer);
        printer.d("SpecialMessage1Font：" + SpecialMessage1Font);
        if (SpecialMessage1Font == 0) {
            return;
        }
        int specialMessage1Length = ByteBufferUtils.bytesToInt(byteBuffer);
        String specialMessage1 = ByteBufferUtils.bytesToHexString(byteBuffer, specialMessage1Length);
        commodity.setSpecialMessage1(specialMessage1);
        if (byteBuffer.get() == 12) {
            int SpecialMessage2Font = ByteBufferUtils.bytesToInt(byteBuffer);
            System.out.println("SpecialMessage2Font：" + SpecialMessage2Font);
            int specialMessage2Length = ByteBufferUtils.bytesToInt(byteBuffer);
            String specialMessage2 = ByteBufferUtils.bytesToHexString(byteBuffer, specialMessage2Length);
            commodity.setSpecialMessage2(specialMessage2);
            if (byteBuffer.get() == 12) {
                int SpecialMessage3Font = ByteBufferUtils.bytesToInt(byteBuffer);
                System.out.println("SpecialMessage3Font：" + SpecialMessage3Font);
                int specialMessage3Length = ByteBufferUtils.bytesToInt(byteBuffer);
                String specialMessage3 = ByteBufferUtils.bytesToHexString(byteBuffer, specialMessage3Length);
                commodity.setSpecialMessage3(specialMessage3);
                if (byteBuffer.get() == 12) {
                    int SpecialMessage4Font = ByteBufferUtils.bytesToInt(byteBuffer);
                    System.out.println("SpecialMessage4Font：" + SpecialMessage4Font);
                    int specialMessage4Length = ByteBufferUtils.bytesToInt(byteBuffer);
                    String specialMessage4 = ByteBufferUtils.bytesToHexString(byteBuffer, specialMessage4Length);
                    commodity.setSpecialMessage4(specialMessage4);
                    if (byteBuffer.get() == 12) {
                        int SpecialMessage5Font = ByteBufferUtils.bytesToInt(byteBuffer);
                        System.out.println("SpecialMessage5Font：" + SpecialMessage5Font);
                        int specialMessage5Length = ByteBufferUtils.bytesToInt(byteBuffer);
                        String specialMessage5 = ByteBufferUtils.bytesToHexString(byteBuffer, specialMessage5Length);
                        commodity.setSpecialMessage5(specialMessage5);
                    }
                }
            }
        }
    }

    @Override
    public void setSocket(Socket socket, int addressFour, Printer printer) {
        this.socket = socket;
        this.addressFour = addressFour;
        this.printer = printer;
    }

    @Override
    public void replyCommand(byte[] bytes) {
        OutputStream socketOut = null;
        try {
            socketOut = socket.getOutputStream();
            socketOut.write(bytes);
            socketOut.flush();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
