package com.wmdigit.digitransfer.util;

import java.io.UnsupportedEncodingException;
import java.nio.ByteBuffer;

public class ByteBufferUtils {

    public static int bytesToInteger(ByteBuffer byteBuffer, int size) {
        byte[] bytes = new byte[size];
        byteBuffer.get(bytes);
        StringBuilder sb = new StringBuilder();

        for (int i = 0; i < bytes.length; ++i) {
            String hex = Integer.toHexString(255 & bytes[i]);
            if (hex.length() == 1) {
                sb.append('0');
            }
            sb.append(hex);
        }
        Integer integer = Integer.valueOf(sb.toString());

        return integer;
    }


    public static String bytesToString(ByteBuffer byteBuffer, int size) {
        byte[] bytes = new byte[size];
        byteBuffer.get(bytes);
        StringBuilder sb = new StringBuilder();

        for (int i = 0; i < bytes.length; ++i) {
            String hex = Integer.toHexString(255 & bytes[i]);
            if (hex.length() == 1) {
                sb.append('0');
            }
            sb.append(hex);
        }
        return sb.toString();
    }

    public static int bytesToInt(ByteBuffer byteBuffer) {
        byte[] bytes = new byte[1];
        byteBuffer.get(bytes);
        return bytes[0];
    }

    public static String bytesToHexString(ByteBuffer byteBuffer, int i) throws UnsupportedEncodingException {
        byte[] bArr = new byte[i];
        byteBuffer.get(bArr);
        return new String(bArr, "GBK").replace("\u0000", "");
    }

}
