package com.wmdigit.transfer.converter;


import com.wmdigit.transfer.constant.ControlTypeEnum;
import com.wmdigit.transfer.constant.DataTypeEnum;
import com.wmdigit.transfer.constant.ScaleTypeEnum;
import com.wmdigit.transfer.domain.CommandHeader;

import java.nio.ByteBuffer;

public class CommandHeaderConverter implements BeanConverter<CommandHeader> {
    public ByteBuffer fromBean(CommandHeader commandHeader) {
        return null;
    }

    public CommandHeader toBean(ByteBuffer byteBuffer) {
        if (byteBuffer == null || byteBuffer.limit() < 15) {
            return null;
        }
        CommandHeader commandHeader = new CommandHeader();
        commandHeader.setStart(byteBuffer.get());
        commandHeader.setTotalLength(byteBuffer.getShort());
        commandHeader.setPageNum(byteBuffer.getShort());
        commandHeader.setCompressed((commandHeader.getTotalLength() & Short.MIN_VALUE) != 0);
        if (commandHeader.isCompressed()) {
            return commandHeader;
        }
        commandHeader.setPageLength(byteBuffer.getShort());
        commandHeader.setCmdrsp(byteBuffer.get());
        commandHeader.setCommand(byteBuffer.getShort());
        commandHeader.setControl(byteBuffer.getShort());
        commandHeader.setDepartno(byteBuffer.getShort());
        commandHeader.setDeviceno(byteBuffer.get());
        short control = commandHeader.getControl();
        commandHeader.setControlType(ControlTypeEnum.fromValue(control & 15));
        int i = (control >> 4) & 255;
        if (i == 120 || i == 130) {
            commandHeader.setScaleType(ScaleTypeEnum.BCOM);
        } else if (i >= 100 && i <= 110) {
            commandHeader.setScaleType(ScaleTypeEnum.BPRO);
        } else if (i == 0 || ((i >= 60 && i <= 68) || i == 255 || i == 15)) {
            if (commandHeader.getDeviceno() == 1 && commandHeader.getPageLength() > 68 && commandHeader.getCommand() == 207) {
                commandHeader.setScaleType(ScaleTypeEnum.BPRO);
            } else if (commandHeader.getDeviceno() == 1 && commandHeader.getPageLength() > 604 && commandHeader.getCommand() == 209) {
                commandHeader.setScaleType(ScaleTypeEnum.BPRO);
            } else {
                commandHeader.setScaleType(ScaleTypeEnum.RL00);
            }
        } else if (i == 222) {
            commandHeader.setScaleType(ScaleTypeEnum.HH00);
        }
        commandHeader.setDataType(DataTypeEnum.fromValue(commandHeader.getCommand(), commandHeader.getScaleType()));
        return commandHeader;
    }

    public CommandHeader toDeleteBean(ByteBuffer byteBuffer) {
        throw new UnsupportedOperationException("Not implemented.");
    }

}
