package com.wmdigit.transfer.converter;


import android.util.Log;

import com.wmdigit.transfer.constant.DataTypeEnum;
import com.wmdigit.transfer.constant.ScaleTypeEnum;
import com.wmdigit.transfer.converter.bpro.AccBproConverter;
import com.wmdigit.transfer.converter.bpro.PluBproConverter;
import com.wmdigit.transfer.converter.hh.AccHhConverter;
import com.wmdigit.transfer.converter.hh.PluHhConverter;
import com.wmdigit.transfer.converter.rl00.AccRl00Converter;
import com.wmdigit.transfer.converter.rl00.PluRl00Converter;
import com.wmdigit.transfer.domain.DataBean;

public class ConverterFactory {
    public static BeanConverter<? extends DataBean> create(ScaleTypeEnum scaleTypeEnum, DataTypeEnum dataTypeEnum) {
        if (ScaleTypeEnum.BPRO == scaleTypeEnum || ScaleTypeEnum.BCOM == scaleTypeEnum) {
            if (DataTypeEnum.PLU == dataTypeEnum) {
                return new PluBproConverter();
            }
            if (DataTypeEnum.ACC == dataTypeEnum) {
                return new AccBproConverter();
            }
        } else if (ScaleTypeEnum.RL00 == scaleTypeEnum) {
            if (DataTypeEnum.PLU == dataTypeEnum) {
                return new PluRl00Converter();
            }
            if (DataTypeEnum.ACC == dataTypeEnum) {
                return new AccRl00Converter();
            }
        } else if (ScaleTypeEnum.HH00 == scaleTypeEnum) {
            if (DataTypeEnum.PLU == dataTypeEnum) {
                return new PluHhConverter();
            }
            if (DataTypeEnum.ACC == dataTypeEnum) {
                return new AccHhConverter();
            }
        }
        return null;
    }
}
