package com.wmdigit.transfer.converter.bpro;


import com.wmdigit.transfer.constant.FixedWeightUsageEnum;
import com.wmdigit.transfer.constant.PrintDateFormatEnum;
import com.wmdigit.transfer.converter.BeanConverter;
import com.wmdigit.transfer.domain.Plu;
import com.wmdigit.transfer.wrapper.DataPackUtils;

import java.io.UnsupportedEncodingException;
import java.nio.ByteBuffer;

public class PluBproConverter implements BeanConverter<Plu> {
    public ByteBuffer fromBean(Plu plu) {
        return null;
    }

    public Plu toBean(ByteBuffer byteBuffer) throws UnsupportedEncodingException {
        Plu plu = new Plu();
        plu.setPluNo(byteBuffer.getInt());
        plu.setItemNo(CC.bytesToText(byteBuffer, 13));
        byteBuffer.getShort();
        plu.setDeptNo(byteBuffer.get());
        plu.setNameTextA(CC.doubleBytesToText(byteBuffer, 28));
        plu.setUnitPriceA(byteBuffer.getInt());
        plu.setUnitPriceB(byteBuffer.getInt());
        plu.setLabelNoA(byteBuffer.get());
        plu.setLabelNoB(byteBuffer.get());
        plu.setTareNoA(byteBuffer.get());
        plu.setPriceRuleNo(byteBuffer.get());
        byteBuffer.getInt();
        if (DataPackUtils.getInstance().getFixedWeightUse() == FixedWeightUsageEnum.FIXED_WEIGHT) {
            plu.setFixWeight(((double) byteBuffer.getInt()) / 10.0d);
        } else {
            plu.setPriceUnitDesA(CC.bytesToText(byteBuffer, 4));
            plu.setPriceUnitDesB(plu.getPriceUnitDesA());
        }
        plu.setGroupNo(byteBuffer.getInt());
        plu.setBarcodeNo(byteBuffer.getShort());
        plu.setSafeHandingNo(byteBuffer.get());
        plu.setGraphicNoA(String.valueOf(byteBuffer.get()));
        byte b = byteBuffer.get();
        byte b2 = byteBuffer.get();
        byte b3 = byteBuffer.get();
        byteBuffer.get();
        plu.setPriceUnitA(b & 3);
        plu.setPriceUnitB(plu.getPriceUnitA());
        boolean z = true;
        plu.setPriceChangeFlagA(((b >> 2) & 1) == 1);
        plu.setPriceChangeFlagB(plu.isPriceChangeFlagA());
        plu.setDiscountFlagA(((b >> 3) & 1) == 1);
        plu.setDiscountFlagB(plu.isDiscountFlagA());
        int i = b >> 4;
        plu.setPrintPackedDate(i != 0);
        if (plu.isPrintPackedDate()) {
            PrintDateFormatEnum fromValue = PrintDateFormatEnum.fromValue(i);
            if (fromValue != null) {
                plu.setPackedDateFormat(fromValue.format());
            }
        }
        byte b4 = (byte) (b2 & 15);
        plu.setPrintSellByDate(b4 != 0);
        if (plu.isPrintSellByDate()) {
            PrintDateFormatEnum fromValue2 = PrintDateFormatEnum.fromValue(b4);
            if (fromValue2 != null) {
                plu.setSellByDateFormat(fromValue2.format());
            }
        }
        int i2 = b2 >> 4;
        plu.setPrintBestBeforeDate(i2 != 0);
        if (plu.isPrintBestBeforeDate()) {
            PrintDateFormatEnum fromValue3 = PrintDateFormatEnum.fromValue(i2);
            if (fromValue3 != null) {
                plu.setBestBeforeDateFormat(fromValue3.format());
            }
        }
        if (((b3 >> 4) & 1) != 1) {
            z = false;
        }
        plu.setTraceable(z);
        StringBuilder sb = new StringBuilder();
        String str = "";
        sb.append(str);
        sb.append(byteBuffer.getInt());
        plu.setBestBeforeDate(sb.toString());
        StringBuilder sb2 = new StringBuilder();
        sb2.append(str);
        sb2.append(byteBuffer.getInt());
        plu.setSellByDate(sb2.toString());
        plu.setEtNo(byteBuffer.getInt());
        plu.setNutritionNo(byteBuffer.getInt());
        plu.setNameTextB(CC.doubleBytesToText(byteBuffer, 150));
        return plu;
    }

    public Plu toDeleteBean(ByteBuffer byteBuffer) {
        Plu plu = new Plu(byteBuffer.getInt());
        byteBuffer.getInt();
        byteBuffer.getInt();
        return plu;
    }
}
