package com.wmdigit.transfer.converter.rl00;


import android.util.Log;

import com.wmdigit.transfer.constant.FixedWeightUsageEnum;
import com.wmdigit.transfer.converter.BeanConverter;
import com.wmdigit.transfer.domain.Plu;
import com.wmdigit.transfer.wrapper.DataPackUtils;

import java.io.UnsupportedEncodingException;
import java.nio.ByteBuffer;

public class PluRl00Converter implements BeanConverter<Plu> {
    public ByteBuffer fromBean(Plu plu) {
        return null;
    }

    public Plu toBean(ByteBuffer byteBuffer) throws UnsupportedEncodingException {
        Plu plu = new Plu();
        plu.setPluNo(byteBuffer.getInt());
        plu.setItemNo(CC.bytesToText(byteBuffer, 13));
        plu.setNameTextA(CC.bytesToText(byteBuffer, 28));
        byteBuffer.get();
        plu.setUnitPriceA(byteBuffer.getInt());
        plu.setLabelNoA(byteBuffer.get());
        plu.setTareNoA(byteBuffer.get());
        byteBuffer.getShort();
        if (DataPackUtils.getInstance().getFixedWeightUse() == FixedWeightUsageEnum.FIXED_WEIGHT) {
            plu.setFixWeight((double) byteBuffer.getInt());
        } else {
            plu.setPriceUnitDesA(CC.bytesToText(byteBuffer, 4));
            plu.setPriceUnitDesB(plu.getPriceUnitDesA());
        }
        plu.setGroupNo(byteBuffer.getShort());
        short s = byteBuffer.getShort();
        plu.setPriceUnitA(s & 1);
        boolean z = true;
        plu.setPriceChangeFlagA(((s >> 1) & 1) == 1);
        plu.setDiscountFlagA(((s >> 5) & 1) == 1);
        if (((s >> 13) & 1) != 1) {
            z = false;
        }
        plu.setTraceable(z);
        StringBuilder sb = new StringBuilder();
        String str = "";
        sb.append(str);
        sb.append(byteBuffer.getShort());
        plu.setBestBeforeDate(sb.toString());
        StringBuilder sb2 = new StringBuilder();
        sb2.append(str);
        sb2.append(byteBuffer.getShort());
        plu.setSellByDate(sb2.toString());
        plu.setEtNo(byteBuffer.getShort());
        return plu;
    }

    public Plu toDeleteBean(ByteBuffer byteBuffer) {
        Plu plu = new Plu(byteBuffer.getInt());
        byteBuffer.getInt();
        byteBuffer.getInt();
        return plu;
    }
}
