package com.wmdigit.transfer.wrapper;

import com.wmdigit.transfer.constant.ControlTypeEnum;
import com.wmdigit.transfer.domain.CommandHeader;
import com.wmdigit.transfer.domain.DataBean;

import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.List;

public class DataPackWrapper {

    private List<DataBean> beanList = new ArrayList();
    private final ByteBuffer inBuffer;
    private final CommandHeader inHeader;
    private boolean isResultOk = true;
    private byte[] outBytes;
    private CommandHeader outHeader;

    public DataPackWrapper(boolean z) {
        this.isResultOk = z;
        this.inBuffer = null;
        this.inHeader = null;
    }

    public DataPackWrapper(ByteBuffer byteBuffer, CommandHeader commandHeader) {
        this.inBuffer = byteBuffer;
        this.inHeader = commandHeader;
    }

    public boolean isRead() {
        ControlTypeEnum controlType = this.inHeader.getControlType();
        return (ControlTypeEnum.WRITE == controlType || ControlTypeEnum.DELETE == controlType || ControlTypeEnum.DELETE_ALL == controlType) ? false : true;
    }

    public boolean isWrite() {
        return ControlTypeEnum.WRITE == this.inHeader.getControlType();
    }

    public boolean isDelete() {
        return ControlTypeEnum.DELETE == this.inHeader.getControlType();
    }

    public boolean isDeleteAll() {
        return ControlTypeEnum.DELETE_ALL == this.inHeader.getControlType();
    }

    public DataPackWrapper addBean(DataBean dataBean) {
        this.beanList.add(dataBean);
        return this;
    }

    public List<DataBean> getBeanList() {
        return this.beanList;
    }

    public void setBeanList(List<DataBean> list) {
        this.beanList = list;
    }

    public byte[] getOutBytes() {
        return this.outBytes;
    }

    public void setOutBytes(byte[] bArr) {
        this.outBytes = bArr;
    }

    public ByteBuffer getInBuffer() {
        return this.inBuffer;
    }

    public CommandHeader getInHeader() {
        return this.inHeader;
    }

    public boolean isResultOk() {
        return this.isResultOk;
    }

    public void setResultOk(boolean z) {
        this.isResultOk = z;
    }

    public CommandHeader getOutHeader() {
        return this.outHeader;
    }

    public void setOutHeader(CommandHeader commandHeader) {
        this.outHeader = commandHeader;
    }

}
