package com.wmdigit.socketdemo;

import android.os.CountDownTimer;
import android.util.Log;

public class CountDownTimerUtils {

    private CountDownTimer countDownTimer;

    private CountDownTimerUtils() {
    }

    public static CountDownTimerUtils getInstance() {
        return Single.COUNT_DOWN_TIMER_UTILS;
    }

    public void setTime(final TimerListener timerListener) {
        if (null == countDownTimer) {
            countDownTimer = new CountDownTimer(5 * 1000L, 1000) {
                @Override
                public void onTick(long l) {
                    Log.e("定时器", l / 1000 + "");
                }

                @Override
                public void onFinish() {
                    Log.e("定时器", Thread.currentThread().getName());
                    //执行获取灯的状态
                    timerListener.timeFinish();
                }
            };
        }
    }

    private static final class Single {
        private static final CountDownTimerUtils COUNT_DOWN_TIMER_UTILS = new CountDownTimerUtils();
    }

    public void startTime() {
        if (null != countDownTimer) {
            countDownTimer.start();
        }
    }

    /**
     * 取消定时
     */
    public void cancelTime() {
        if (null != countDownTimer) {
            countDownTimer.cancel();
        }
    }


}
